#define MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/io.h>

#include <asm/rt_irq.h>
#include <asm/rt_time.h>
#include <rtl_fifo.h>
#include <rtl_sched.h>

#include "common.h"

#define TIMEOUT 100000
#define SKIP 4000
#define USE_FPU 0

int period;
RTIME expected;
RT_TASK task;
struct sample samp;

void fun(int task) {

	int diff;
	int skip;
	int average;
	int min_diff;
	int max_diff;

	while (1) {
		min_diff = 1000000000;
		max_diff = -1000000000;
		average = 0;

		for (skip = 0; skip < SKIP; skip++) {
			expected += period;
			rt_task_wait_period();

			diff = (int)count2nano(rt_get_time() - expected);
			if (diff < min_diff) {
				min_diff = diff;
			}
			if (diff > max_diff) {
				max_diff = diff;
			}
		average += diff;
		}
		samp.min = min_diff;
		samp.max = max_diff;
		samp.index = average/SKIP;
		rtf_put(DEBUG_FIFO, &samp, sizeof(samp));
	}
}

int init_module(void)
{
	RTIME start;
	rtf_create(DEBUG_FIFO, 16000);
	rt_linux_use_fpu(USE_FPU);
	rt_task_init(&task, fun, 0, 3000, 0, USE_FPU, 0);
	rt_set_oneshot_mode();
	period = start_rt_timer(nano2count(200000));
	start = rt_get_time() + nano2count(10000000);
	expected = start;
	rt_task_make_periodic(&task, start, period);
	return 0;
}

void cleanup_module(void)
{
	rtf_destroy(DEBUG_FIFO);
	stop_rt_timer();	
	rt_task_delete(&task);
}
