/* DEFINITIONS */

#define BOOLEAN int
#define TRUE 1
#define FALSE 0

/* DEFINITION CMDCLK */

extern void CommandClock_Put(char command);
extern void CommandClock_Get(char *command);

/* DEFINITION CMDCRN */

extern void CommandChrono_Put(char command);
extern void CommandChrono_Get(char *command);

/* DEFINITION DISPCLK */

typedef struct {char chain[12];} MenageHmsh_tChain11;
typedef struct {int hours, minutes, seconds, hundredthes;} MenageHmsh_tHour;

extern void  MenageHmsh_Initialise(MenageHmsh_tHour *h);
extern void  MenageHmsh_InitialiseHundredthes(MenageHmsh_tHour *h);
extern void  MenageHmsh_AdvanceHours(MenageHmsh_tHour *h);
extern void  MenageHmsh_AdvanceMinutes(MenageHmsh_tHour *h);
extern void  MenageHmsh_AdvanceSeconds(MenageHmsh_tHour *h);
extern void  MenageHmsh_PlusNSeconds(int n, MenageHmsh_tHour *h);
extern void  MenageHmsh_PlusOneUnit(MenageHmsh_tHour *h, BOOLEAN *CarrySeconds);
extern void  MenageHmsh_Convert(MenageHmsh_tHour h, BOOLEAN hundredthes, MenageHmsh_tChain11 *chain);
extern BOOLEAN MenageHmsh_Equal(MenageHmsh_tHour h1, MenageHmsh_tHour h2);

typedef enum {destClock, destChrono} Display_tDest;

extern void Display_PutHour(MenageHmsh_tChain11 chain);
extern void Display_PutTimes(MenageHmsh_tChain11 chain);
extern void Display_Get(MenageHmsh_tChain11 *chain, Display_tDest *receiver);
