/* KEYBOARD */

#include <stdio.h>
#include <errno.h>
#include <termio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <signal.h>
#include <fcntl.h>
#include <tcl.h>
#include <unistd.h>
#include <curses.h>
#include <sys/ioctl.h>

#include <rtl_fifo.h>
#include <asm/rt_time.h>

static void menu(void)
{
	printf("___________________________________________________\n");
	printf("|                CLOCK COMMANDS                   |\n");
	printf("|t-stop clock, r-run, h-hour, m-minutes, s-seconds|\n");
	printf("|              CHRONOMETER COMMANDS               |\n");
	printf("|    c-run, i-display intermediate time, e-stop   |\n");
	printf("|               CONTROL COMMANDS                  |\n");
	printf("| n-show/hide display, p-display menu f-end this  |\n");
	printf("---------------------------------------------------\n");
	printf("\n");
}

void main()
{
	int Keyboard, pid;
	char ch;
	char k = 'k';
	struct termio my_kb, orig_kb;

	pid = fork();
	if (!pid) {
		execlp("screen", "screen");
	}
	usleep(10000);
	
	if ((Keyboard = open("/dev/rtf0", O_WRONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf0\n");
		exit(1);
	}

	if (write(Keyboard, &k, 1) < 0 ) {
		fprintf(stderr, "Can't send initial command to RT-task\n");
		exit(1);
	}

	ioctl(0, TCGETA, &orig_kb);
	my_kb = orig_kb;
	my_kb.c_lflag &= ~ECHO;
	menu();
	do {
		ioctl(0, TCSETAF, &my_kb);
	        ch = getchar();
		ioctl(0, TCSETAF, &orig_kb);
	        if (ch == 'p' || ch == 'P') {
			menu();
		}
		if (write(Keyboard, &ch, 1) < 0 ) {
			fprintf(stderr, "Can't send command to RT-task\n");
			exit(1);
		}
	} while(ch != 'f');
	kill(pid, SIGKILL);
	exit(0);
}
